<?php
/***************************************************************************
 *                            aprs_placefile.php
 *                           --------------------
 *   begin                : Saturday, Sep 8, 2007
 *   copyright            : (C) 2007 Keith Watson - VA3UPL
 *   email                : kwatson@underwaterlabs.com
 *
 *   $Id: aprs_placefile.php,v 1.1 2007/09/08 15:42:00 kwatson Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ***************************************************************************/

  include('include/functions.inc.php');
  include('config.inc.php');
  header ("content-type: text/plain");
  
?>
# aprs placefile
# (C) 2007 Keith Watson - VA3UPL
<?php

  // database connect
  // set your credentials in config.in.php
  mysql_connect($host, $username, $password);
  @mysql_select_db($database) or die( "Unable to select database");

  // Code matrix to convert aprs symbols into images
  $codes = "";
  $codes = $codes."!\"#$%&'()*+,-./0";
  $codes = $codes."123456789:;<=>?@";
  $codes = $codes."ABCDEFGHIJKLMNOP";
  $codes = $codes."QRSTUVWXYZ[\\]^_~";
  $codes = $codes."abcdefghijklmnop";
  $codes = $codes."qrstuvwxyz{|}~  ";

  $count = 0;
  for ($index = 0; $index < 16 * 6; $index++) {
    $count++;
    $symbols["/"][$codes[$index]] = $count;
    $symbols["\\"][$codes[$index]] = $count + 16 * 6;
  }

  if ($allowOverride) {
    $title = getRequestParam("title", $title);
    $lat1 = getRequestParam("lat1", $lat1);
    $lat2 = getRequestParam("lat2", $lat2);
    $lon1 = getRequestParam("lon1", $lon1);
    $lon2 = getRequestParam("lon2", $lon2);
    $threshold = getRequestParam("threshold", $threshold);
    $refresh = getRequestParam("refresh", $refresh);
    $hours = getRequestParam("hours", $hours);
  }
  
  Print("Title: APRS Positions - ".$title." - Provided by VA3UPL\r\n");
  Print("Refresh: ".$refresh.""."\r\n");
  Print("Threshold: ".$threshold.""."\r\n");
  Print("Font: 1, 13, 1, \"Arial\""."\r\n");
  Print("IconFile: 1, 20, 20, 10, 10, ".$imagePath."symbols.png"."\r\n");
  Print("IconFile: 2, 20, 20, 10, 20, ".$imagePath."arrows.png"."\r\n");

  $sql = "".
    "SELECT lastposition.source, "."\r\n".
    "       lastposition.latitude, "."\r\n".
    "       lastposition.longitude, "."\r\n".
    "       lastposition.symbol_table, "."\r\n".
    "       lastposition.symbol_code, "."\r\n".
    "       lastposition.course, "."\r\n".
    "       lastposition.speed, "."\r\n".
    "       lastposition.packet_date, "."\r\n".
    "       IFNULL(lastweather.source, '') AS lastweather_source, "."\r\n".
    "       lastweather.wind_direction, "."\r\n".
    "       lastweather.temperature, "."\r\n".
    "       lastweather.wind_gust, "."\r\n".
    "       lastweather.rain_hour, "."\r\n".
    "       lastweather.humidity, "."\r\n".
    "       lastweather.barometer, "."\r\n".
    "       lastweather.wind_speed "."\r\n".
    "FROM lastposition "."\r\n".
    "LEFT OUTER JOIN lastweather ON lastweather.source = lastposition.source "."\r\n".
    "WHERE lastposition.latitude > ".$lat1." "."\r\n".
    "  AND lastposition.latitude < ".$lat2." "."\r\n".
    "  AND lastposition.longitude < ".$lon2." "."\r\n".
    "  AND lastposition.longitude > ".$lon1." "."\r\n".
    "  AND lastposition.packet_date BETWEEN DATE_SUB(NOW(), INTERVAL ".$hours." HOUR) AND NOW() "."\r\n".
    "";
  $result = mysql_query($sql);
  $rowCount = mysql_numrows($result);
  $rowNum = 0;
  while ($rowNum < $rowCount) {
    $latitude = mysql_result($result,$rowNum, "latitude");
    $longitude = mysql_result($result,$rowNum, "longitude");
    $callSign = mysql_result($result,$rowNum, "source");
    $symbolTable = mysql_result($result,$rowNum, "symbol_table");
    $symbolCode = mysql_result($result,$rowNum, "symbol_code");
    $lastHeard = mysql_result($result,$rowNum, "packet_date");
    if (mysql_result($result,$rowNum, "lastweather_source") == "") {
      $isWeather = false;
    }
    else {
      $isWeather = true;
    }
    $localPacketDate = strtotime($lastHeard) + Date("Z");

    if ($symbolTable != "/" && $symbolTable != "\\") {
      $symbolTable = "/";
    }
    if ($symbolCode == "") {
      $symbolCode = "/";
    }
    if (!strpos($codes, $symbolCode)) {
      $symbolCode = "/";
    }

    $symbol = $symbols[$symbolTable][$symbolCode];
    if ($symbol * 1 == 0) {
      $symbol = 3;
    }

    $message = strtoupper($callSign)."\\n";
    $message = $message."Last Heard: ".Date("Y-m-d h:i:s", $localPacketDate)." est\\n";

    if (mysql_result($result,$rowNum, "speed") * 1 > 0) {
      $message = $message."Speed: ".(int)(mysql_result($result,$rowNum, "speed") * 92.6 / 50)." kph\\n";
      $message = $message."Heading: ".mysql_result($result,$rowNum, "course")."\\n";
      Print("Icon: ".$latitude.", ".$longitude.", ".mysql_result($result,$rowNum, "course").", 2, 1, \"\""."\r\n");
    
    }

    if ($isWeather) {
      $message = $message."Temperature: ".(int)(mysql_result($result,$rowNum, "temperature"))."\\n";
      $message = $message."Barometer: ".(int)(mysql_result($result,$rowNum, "barometer"))."\\n";
      $message = $message."Humidity: ".(int)(mysql_result($result,$rowNum, "humidity"))."%\\n";
      if (mysql_result($result,$rowNum, "wind_speed") * 1 > 0) {
        $message = $message."Wind Direction: ".mysql_result($result,$rowNum, "wind_direction")."\\n";
        $message = $message."Wind Speed: ".(int)(mysql_result($result,$rowNum, "wind_speed") * 92.6 / 50)." kph\\n";
        Print("Icon: ".$latitude.", ".$longitude.", ".mysql_result($result,$rowNum, "wind_direction").", 2, 1, \"\""."\r\n");
      }
      if (mysql_result($result,$rowNum, "wind_gust") * 1 > 0) {
        $message = $message."Wind Gust: ".(int)(mysql_result($result,$rowNum, "wind_gust") * 92.6 / 50)." kph\\n";
      }
      if (mysql_result($result,$rowNum, "rain_hour") * 1 > 0) {
        $message = $message."Rain Hour: ".(int)(mysql_result($result,$rowNum, "rain_hour") * 2.54 * 10)." mm\\n";
      }
    }
    $message = substr($message, 0, strlen($message) - 2);
    
    Print("Color: 255 255 0"."\r\n");
    Print("Icon: ".$latitude.", ".$longitude.", 0, 1, ".$symbol.", \"".$message."\""."\r\n");
    $rowNum++;
  }
  // close the databse connection
  mysql_close();
?>
